import { Injectable, Inject, Injector } from "@angular/core";
import { zip } from "rxjs";
import { catchError } from "rxjs/operators";
import { HttpClient } from "@angular/common/http";

/**
 * 用于应用启动时
 * 一般用来获取应用所需要的基础数据等
 */
@Injectable()
export class StartupService {
  constructor(private httpClient: HttpClient) {}

  private viaHttp(resolve: any, reject: any) {
    zip(this.httpClient.get("assets/tmp/app-data.json"))
      .pipe(
        // 接收其他拦截器后产生的异常消息
        catchError(([appData]) => {
          resolve(null);
          return [appData];
        })
      )
      .subscribe(
        ([appData]) => {
          // setting language data

          // application data
          const res: any = appData;
          console.log("启动应用");
          console.log(res);

          // 应用信息：包括站点名、描述、年份
        },
        () => {},
        () => {
          resolve(null);
        }
      );
  }

  load(): Promise<any> {
    // only works with promises
    // https://github.com/angular/angular/issues/15088
    return new Promise((resolve, reject) => {
      this.viaHttp(resolve, reject);
      // mock：请勿在生产环境中这么使用，viaMock 单纯只是为了模拟一些数据使脚手架一开始能正常运行
      // this.viaMock(resolve, reject);
    });
  }
}
